﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Windows.Forms;
using ThinkGeo.MapSuite;
using ThinkGeo.MapSuite.Drawing;
using ThinkGeo.MapSuite.Layers;
using ThinkGeo.MapSuite.Shapes;
using ThinkGeo.MapSuite.Styles;
using ThinkGeo.MapSuite.WinForms;

namespace Post8690
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            winformsMap1.CurrentExtent = new RectangleShape(-173.559264540672, 132.188083648682, 132.188083782858, -173.559264674849);
            winformsMap1.MapUnit = GeographyUnit.Meter;

            var overlay = new LayerOverlay();
            var tileCache = new FileBitmapTileCache(@"D:\Test\Tiles", "Test");
            MapSuiteTileMatrix tileMatrix = new MapSuiteTileMatrix(winformsMap1.CurrentScale, 256, 256, GeographyUnit.Meter);
            tileMatrix.BoundingBoxUnit = GeographyUnit.Meter;
            tileCache.TileMatrix = tileMatrix;

            var tiles = tileCache.GetTiles(winformsMap1.CurrentExtent);

            var tileInMemoryLayer = new InMemoryFeatureLayer();
            tileInMemoryLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = new AreaStyle(new GeoPen(GeoColor.SimpleColors.Black, 2.0f));
            tileInMemoryLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            foreach (var tile in tiles)
            {
                tileInMemoryLayer.InternalFeatures.Add(new Feature(tile.BoundingBox));
            }

            var textLayer = new InMemoryFeatureLayer();
            textLayer.InternalFeatures.Add(new Feature(new PointShape(62.578125, -36.5625)));
            textLayer.ZoomLevelSet.ZoomLevel01.DefaultPointStyle = new CustomizedPointStyle(PointSymbolType.Circle, new GeoSolidBrush(GeoColor.SimpleColors.Red), 20);
            textLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            overlay.Layers.Add(tileInMemoryLayer);
            overlay.Layers.Add(textLayer);
            winformsMap1.Overlays.Add(overlay);

            winformsMap1.Refresh();
        }

        private void winformsMap1_MapClick(object sender, MapClickWinformsMapEventArgs e)
        {
            var feature = new Feature(e.WorldLocation);
        }
    }

    public class CustomizedPointStyle : PointStyle
    {
        public CustomizedPointStyle(PointSymbolType symbolType, GeoSolidBrush brush, int size)
            : base(symbolType, brush, size)
        {

        }

        protected override void DrawCore(IEnumerable<Feature> features, GeoCanvas canvas, Collection<SimpleCandidate> labelsInThisLayer, Collection<SimpleCandidate> labelsInAllLayers)
        {
            base.DrawCore(features, canvas, labelsInThisLayer, labelsInAllLayers);
            
            canvas.DrawTextWithWorldCoordinate("Example Text", new GeoFont("Arial", 75.0f), new GeoSolidBrush(GeoColor.SimpleColors.Black), 62.578125, -36.5625, DrawingLevel.LevelThree);
        }
    }

}
